SystemOrganization addCategory: #'Pier-LightBox'!

!PRVisitor methodsFor: '*pier-lightbox-visiting' stamp: 'lr 5/24/2007 21:32'!
visitLightBoxLink: anObject
	self visitDocumentItem: anObject! !

WAComponent subclass: #PRLightBoxView
	instanceVariableNames: 'context structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-LightBox'!

!PRLightBoxView methodsFor: 'accessing' stamp: 'lr 5/24/2007 22:02'!
context
	^ context! !

!PRLightBoxView methodsFor: 'accessing' stamp: 'lr 5/24/2007 22:02'!
context: aContext
	context := aContext! !

!PRLightBoxView methodsFor: 'rendering' stamp: 'lr 4/8/2009 20:14'!
renderBodyOn: html
	html rendererInstance
		continue: self structure 
		in: self on: html! !

!PRLightBoxView methodsFor: 'rendering' stamp: 'lr 5/29/2007 20:40'!
renderContentOn: html
	html div
		class: 'head';
		with: [ self renderHeadOn: html ].
	html div
		class: 'body';
		with: [ self renderBodyOn: html ]! !

!PRLightBoxView methodsFor: 'rendering' stamp: 'lr 5/29/2007 20:39'!
renderHeadOn: html
	html heading
		level: 1;
		with: self structure title.
	html anchor
		callback: [ self answer ];
		with: [ html html: '&times;' ].
	html div style: 'clear: both'! !

!PRLightBoxView methodsFor: 'accessing' stamp: 'lr 5/24/2007 22:01'!
structure
	^ structure! !

!PRLightBoxView methodsFor: 'accessing' stamp: 'lr 5/24/2007 22:01'!
structure: aStructure
	structure := aStructure! !

!PRViewRenderer methodsFor: '*pier-lightbox-visiting' stamp: 'lr 5/28/2007 16:31'!
openLightBox: aStructure
	component lightbox: (PRLightBoxView new
		context: self context;
		structure: aStructure;
		yourself)! !

!PRViewRenderer methodsFor: '*pier-lightbox-visiting' stamp: 'lr 3/25/2009 00:03'!
visitLightBoxLink: aLightbox
	| link |
	link := aLightbox link.
	link isBroken ifTrue: [ ^ self visit: link ].
	html anchor
		class: 'internal';
		title: aLightbox title;
		callback: [ self openLightBox: link target ];
		with: [
			(self linkRendererFor: link)
				component: component;
				renderer: html;
			 	visitLink: link ]! !

!PRWikiWriter methodsFor: '*pier-lightbox-visiting' stamp: 'lr 5/24/2007 21:37'!
visitLightBoxLink: anObject
	self nextPut: anObject class markup first.
	self visit: anObject link.
	self nextPut: anObject class markup first! !

!PRTextWriter methodsFor: '*pier-lightbox-visiting' stamp: 'lr 5/24/2007 21:38'!
visitLightBoxLink: anObject
	self visit: anObject link! !

!PRPluggableVisitor methodsFor: '*pier-lightbox-visiting' stamp: 'lr 5/24/2007 21:53'!
visitLightBoxLink: anObject
	super visitLightBoxLink: anObject.
	self visit: anObject link! !

PRDocumentItem subclass: #PRLightBoxLink
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-LightBox'!

!PRLightBoxLink class methodsFor: 'initialization' stamp: 'lr 5/24/2007 21:33'!
initialize
	PRDocumentParser textMatcher at: self markup put: self! !

!PRLightBoxLink class methodsFor: 'testing' stamp: 'lr 5/24/2007 21:31'!
isAbstract
	^ false! !

!PRLightBoxLink class methodsFor: 'accessing' stamp: 'lr 5/24/2007 21:37'!
markup
	^ '+' , PRLink markupEmbedded! !

!PRLightBoxLink class methodsFor: 'instance-creation' stamp: 'lr 5/24/2007 21:33'!
parse: aString with: aParser
	^ self new link: (PRLink parse: aString allButFirst allButLast with: aParser)! !

!PRLightBoxLink class methodsFor: 'initialization' stamp: 'lr 5/24/2007 21:21'!
unload
	PRDocumentParser textMatcher removeKey: self markup! !

!PRLightBoxLink methodsFor: 'visiting' stamp: 'lr 5/24/2007 21:31'!
accept: aVisitor
	aVisitor visitLightBoxLink: self! !

!PRLightBoxLink methodsFor: 'accessing' stamp: 'lr 5/24/2007 21:24'!
link
	^ link! !

!PRLightBoxLink methodsFor: 'accessing' stamp: 'lr 5/24/2007 21:24'!
link: aLink
	link := aLink! !

!PRLightBoxLink methodsFor: 'accessing' stamp: 'lr 5/24/2007 21:45'!
owner: anObject
	super owner: anObject.
	self link owner: anObject! !

!PRLightBoxLink methodsFor: 'accessing-delegated' stamp: 'dc 10/4/2007 09:58'!
title
	^ self link title! !
PRLightBoxLink initialize!
